/******************************************************************************
*
* .SLF Utils
* Copyright (C) 2000 by Athman Boukhaoua
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
******************************************************************************/


enum
{
	FILE_NOT_FOUND=1, FILE_BUGGY, MEMORY_ALLOCATION_FAILED, NO_LIST_LOADED, NO_FILES_EXTRACTED, FILE_NOT_CREATED
};

class ListItem
{
public:
	char name[256], dir[256];
	DWORD pos, length;
};

class SlfWorker
{
public:
	SlfWorker();
	~SlfWorker();
	bool Load(char *filename);
	bool Extract(char *wildcard);
	char *LastErrorString();
	int GetCount() { return(count); }
	char *GetItemName(int i);
	char *GetItemDir(int i);
	int GetItemLength(int i);
private:
	FILE *slffile;
	int count;
	char basedir[256];
	ListItem *li;
	int LastError;
	bool WildcardMatch(char *n, char *w);
};
